
/* RJTimeLineManager.h */

#ifndef ROKOJORI__TIME_LINE_MANAGER_H
#define ROKOJORI__TIME_LINE_MANAGER_H

#include "./RJGodotHeaders.h"
#include "./RJTimeLine.h"
#include "./RJNetworkNode.h"




class RJTimeLineManager : public RJNetworkNode 
{
  GDCLASS( RJTimeLineManager, RJNetworkNode );

protected:
  static void _bind_methods();
  

  

public:

  
  //  getTimeLineIndex( Ref<RJTimeLine> timeLine ) : int
  GDVIRTUAL1R( int, getTimeLineIndex, Ref<RJTimeLine> );
  
  //  getTimeLineSize() : int
  GDVIRTUAL0R( int, getTimeLineSize );
  
  //  createID() : int
  GDVIRTUAL0R( int, createID );
  
  //  getLastPosition( int timeLineIndex ) : double
  GDVIRTUAL1R( double, getLastPosition, int );
  
  //  getPosition( int timeLineIndex ) : double
  GDVIRTUAL1R( double, getPosition, int );
  
  //  setPosition( int timeLineIndex, double position ) : void
  GDVIRTUAL2( setPosition, int, double );
  
  //  getSpeed( int timeLineIndex ) : double
  GDVIRTUAL1R( double, getSpeed, int );
  
  //  setSpeed( int timeLineIndex, double speed ) : void
  GDVIRTUAL2( setSpeed, int, double );
  
  //  getPlayState( int timeLineIndex ) : bool
  GDVIRTUAL1R( bool, getPlayState, int );
  
  //  setPlayState( int timeLineIndex, bool playState ) : void
  GDVIRTUAL2( setPlayState, int, bool );
  
  //  scheduleEvent( int timeLineIndex, double position, int callbackID, bool isPersistent ) : void
  GDVIRTUAL4( scheduleEvent, int, double, int, bool );
  
  //  scheduleSpan( int timeLineIndex, double startPosition, double endPosition, int callbackID, bool isPersistent ) : void
  GDVIRTUAL5( scheduleSpan, int, double, double, int, bool );
  
  //  [signal] onEvent( int callbackID ) : void
  
  //  [signal] onSpan( int callbackID, int spanType ) : void

  //  Constructor
  RJTimeLineManager();

  //  Destructor
  ~RJTimeLineManager();
};


#endif // ROKOJORI__TIME_LINE_MANAGER_H
